<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head><meta http-equiv="content-type" content="text/html; charset=UTF-8" />
<title>TransformationUtil xref</title>
<link type="text/css" rel="stylesheet" href="../../../../../../../../../stylesheet.css" />
</head>
<body>
<div id="overview"><a href="../../../../../../../../../../apidocs/org/eclipse/papyrus/designer/transformation/languages/cpp/library/statemachine/TransformationUtil.html">View Javadoc</a></div><pre>
<a class="jxr_linenumber" name="L1" href="#L1">1</a>   <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L2" href="#L2">2</a>   <em class="jxr_javadoccomment"> * Copyright (c) 2016 CEA LIST.</em>
<a class="jxr_linenumber" name="L3" href="#L3">3</a>   <em class="jxr_javadoccomment"> * </em>
<a class="jxr_linenumber" name="L4" href="#L4">4</a>   <em class="jxr_javadoccomment"> * </em>
<a class="jxr_linenumber" name="L5" href="#L5">5</a>   <em class="jxr_javadoccomment"> * All rights reserved. This program and the accompanying materials</em>
<a class="jxr_linenumber" name="L6" href="#L6">6</a>   <em class="jxr_javadoccomment"> * are made available under the terms of the Eclipse Public License v1.0</em>
<a class="jxr_linenumber" name="L7" href="#L7">7</a>   <em class="jxr_javadoccomment"> * which accompanies this distribution, and is available at</em>
<a class="jxr_linenumber" name="L8" href="#L8">8</a>   <em class="jxr_javadoccomment"> * <a href="http://www.eclipse.org/legal/epl-v10.htm" target="alexandria_uri">http://www.eclipse.org/legal/epl-v10.htm</a>l</em>
<a class="jxr_linenumber" name="L9" href="#L9">9</a>   <em class="jxr_javadoccomment"> * </em>
<a class="jxr_linenumber" name="L10" href="#L10">10</a>  <em class="jxr_javadoccomment"> * Contributors:</em>
<a class="jxr_linenumber" name="L11" href="#L11">11</a>  <em class="jxr_javadoccomment"> *  Van Cam Pham        &lt;VanCam.PHAM@cea.fr&gt;</em>
<a class="jxr_linenumber" name="L12" href="#L12">12</a>  <em class="jxr_javadoccomment"> */</em>
<a class="jxr_linenumber" name="L13" href="#L13">13</a>  <strong class="jxr_keyword">package</strong> org.eclipse.papyrus.designer.transformation.languages.cpp.library.statemachine;
<a class="jxr_linenumber" name="L14" href="#L14">14</a>  
<a class="jxr_linenumber" name="L15" href="#L15">15</a>  <strong class="jxr_keyword">import</strong> com.google.common.base.Objects;
<a class="jxr_linenumber" name="L16" href="#L16">16</a>  <strong class="jxr_keyword">import</strong> com.google.common.collect.Iterables;
<a class="jxr_linenumber" name="L17" href="#L17">17</a>  <strong class="jxr_keyword">import</strong> java.util.ArrayList;
<a class="jxr_linenumber" name="L18" href="#L18">18</a>  <strong class="jxr_keyword">import</strong> java.util.HashMap;
<a class="jxr_linenumber" name="L19" href="#L19">19</a>  <strong class="jxr_keyword">import</strong> java.util.List;
<a class="jxr_linenumber" name="L20" href="#L20">20</a>  <strong class="jxr_keyword">import</strong> java.util.Map;
<a class="jxr_linenumber" name="L21" href="#L21">21</a>  <strong class="jxr_keyword">import</strong> java.util.function.Consumer;
<a class="jxr_linenumber" name="L22" href="#L22">22</a>  <strong class="jxr_keyword">import</strong> org.eclipse.emf.common.util.EList;
<a class="jxr_linenumber" name="L23" href="#L23">23</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Behavior;
<a class="jxr_linenumber" name="L24" href="#L24">24</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Element;
<a class="jxr_linenumber" name="L25" href="#L25">25</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Event;
<a class="jxr_linenumber" name="L26" href="#L26">26</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.FinalState;
<a class="jxr_linenumber" name="L27" href="#L27">27</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.OpaqueBehavior;
<a class="jxr_linenumber" name="L28" href="#L28">28</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Pseudostate;
<a class="jxr_linenumber" name="L29" href="#L29">29</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.PseudostateKind;
<a class="jxr_linenumber" name="L30" href="#L30">30</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Region;
<a class="jxr_linenumber" name="L31" href="#L31">31</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.State;
<a class="jxr_linenumber" name="L32" href="#L32">32</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.StateMachine;
<a class="jxr_linenumber" name="L33" href="#L33">33</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Transition;
<a class="jxr_linenumber" name="L34" href="#L34">34</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Trigger;
<a class="jxr_linenumber" name="L35" href="#L35">35</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Vertex;
<a class="jxr_linenumber" name="L36" href="#L36">36</a>  <strong class="jxr_keyword">import</strong> org.eclipse.xtend2.lib.StringConcatenation;
<a class="jxr_linenumber" name="L37" href="#L37">37</a>  <strong class="jxr_keyword">import</strong> org.eclipse.xtext.xbase.lib.Functions.Function1;
<a class="jxr_linenumber" name="L38" href="#L38">38</a>  <strong class="jxr_keyword">import</strong> org.eclipse.xtext.xbase.lib.IterableExtensions;
<a class="jxr_linenumber" name="L39" href="#L39">39</a>  <strong class="jxr_keyword">import</strong> org.eclipse.xtext.xbase.lib.ListExtensions;
<a class="jxr_linenumber" name="L40" href="#L40">40</a>  
<a class="jxr_linenumber" name="L41" href="#L41">41</a>  @SuppressWarnings(<span class="jxr_string">"all"</span>)
<a class="jxr_linenumber" name="L42" href="#L42">42</a>  <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">class</strong> <a href="../../../../../../../../../org/eclipse/papyrus/designer/transformation/languages/cpp/library/statemachine/TransformationUtil.html">TransformationUtil</a> {
<a class="jxr_linenumber" name="L43" href="#L43">43</a>    <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> Map&lt;org.eclipse.uml2.uml.Class, StateMachine&gt; getStateMachineClass(<strong class="jxr_keyword">final</strong> org.eclipse.uml2.uml.Package pack) {
<a class="jxr_linenumber" name="L44" href="#L44">44</a>      <strong class="jxr_keyword">final</strong> Map&lt;org.eclipse.uml2.uml.Class, StateMachine&gt; map = <strong class="jxr_keyword">new</strong> HashMap&lt;org.eclipse.uml2.uml.Class, StateMachine&gt;();
<a class="jxr_linenumber" name="L45" href="#L45">45</a>      EList&lt;Element&gt; _ownedElements = pack.getOwnedElements();
<a class="jxr_linenumber" name="L46" href="#L46">46</a>      Iterable&lt;org.eclipse.uml2.uml.Class&gt; _filter = Iterables.&lt;org.eclipse.uml2.uml.Class&gt;filter(_ownedElements, org.eclipse.uml2.uml.Class.<strong class="jxr_keyword">class</strong>);
<a class="jxr_linenumber" name="L47" href="#L47">47</a>      <strong class="jxr_keyword">final</strong> Consumer&lt;org.eclipse.uml2.uml.Class&gt; _function = <strong class="jxr_keyword">new</strong> Consumer&lt;org.eclipse.uml2.uml.Class&gt;() {
<a class="jxr_linenumber" name="L48" href="#L48">48</a>        @Override
<a class="jxr_linenumber" name="L49" href="#L49">49</a>        <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> accept(<strong class="jxr_keyword">final</strong> org.eclipse.uml2.uml.Class it) {
<a class="jxr_linenumber" name="L50" href="#L50">50</a>          EList&lt;Behavior&gt; _ownedBehaviors = it.getOwnedBehaviors();
<a class="jxr_linenumber" name="L51" href="#L51">51</a>          Iterable&lt;StateMachine&gt; _filter = Iterables.&lt;StateMachine&gt;filter(_ownedBehaviors, StateMachine.<strong class="jxr_keyword">class</strong>);
<a class="jxr_linenumber" name="L52" href="#L52">52</a>          StateMachine behavior = IterableExtensions.&lt;StateMachine&gt;head(_filter);
<a class="jxr_linenumber" name="L53" href="#L53">53</a>          <strong class="jxr_keyword">boolean</strong> _notEquals = (!Objects.equal(behavior, <strong class="jxr_keyword">null</strong>));
<a class="jxr_linenumber" name="L54" href="#L54">54</a>          <strong class="jxr_keyword">if</strong> (_notEquals) {
<a class="jxr_linenumber" name="L55" href="#L55">55</a>            map.put(it, behavior);
<a class="jxr_linenumber" name="L56" href="#L56">56</a>          }
<a class="jxr_linenumber" name="L57" href="#L57">57</a>        }
<a class="jxr_linenumber" name="L58" href="#L58">58</a>      };
<a class="jxr_linenumber" name="L59" href="#L59">59</a>      _filter.forEach(_function);
<a class="jxr_linenumber" name="L60" href="#L60">60</a>      <strong class="jxr_keyword">return</strong> map;
<a class="jxr_linenumber" name="L61" href="#L61">61</a>    }
<a class="jxr_linenumber" name="L62" href="#L62">62</a>    
<a class="jxr_linenumber" name="L63" href="#L63">63</a>    <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> Pseudostate firstPseudoState(<strong class="jxr_keyword">final</strong> Region region, <strong class="jxr_keyword">final</strong> PseudostateKind kind) {
<a class="jxr_linenumber" name="L64" href="#L64">64</a>      EList&lt;Vertex&gt; _subvertices = region.getSubvertices();
<a class="jxr_linenumber" name="L65" href="#L65">65</a>      <strong class="jxr_keyword">for</strong> (<strong class="jxr_keyword">final</strong> Vertex vertex : _subvertices) {
<a class="jxr_linenumber" name="L66" href="#L66">66</a>        <strong class="jxr_keyword">if</strong> ((vertex instanceof Pseudostate)) {
<a class="jxr_linenumber" name="L67" href="#L67">67</a>          Pseudostate pseudoState = ((Pseudostate) vertex);
<a class="jxr_linenumber" name="L68" href="#L68">68</a>          PseudostateKind _kind = pseudoState.getKind();
<a class="jxr_linenumber" name="L69" href="#L69">69</a>          <strong class="jxr_keyword">boolean</strong> _equals = Objects.equal(_kind, kind);
<a class="jxr_linenumber" name="L70" href="#L70">70</a>          <strong class="jxr_keyword">if</strong> (_equals) {
<a class="jxr_linenumber" name="L71" href="#L71">71</a>            <strong class="jxr_keyword">return</strong> pseudoState;
<a class="jxr_linenumber" name="L72" href="#L72">72</a>          }
<a class="jxr_linenumber" name="L73" href="#L73">73</a>        }
<a class="jxr_linenumber" name="L74" href="#L74">74</a>      }
<a class="jxr_linenumber" name="L75" href="#L75">75</a>      <strong class="jxr_keyword">return</strong> <strong class="jxr_keyword">null</strong>;
<a class="jxr_linenumber" name="L76" href="#L76">76</a>    }
<a class="jxr_linenumber" name="L77" href="#L77">77</a>    
<a class="jxr_linenumber" name="L78" href="#L78">78</a>    <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> List&lt;State&gt; findCompositeStatesInRegion(<strong class="jxr_keyword">final</strong> Vertex des1, <strong class="jxr_keyword">final</strong> Vertex des2) {
<a class="jxr_linenumber" name="L79" href="#L79">79</a>      ArrayList&lt;State&gt; ret = <strong class="jxr_keyword">new</strong> ArrayList&lt;State&gt;();
<a class="jxr_linenumber" name="L80" href="#L80">80</a>      <strong class="jxr_keyword">final</strong> ArrayList&lt;State&gt; path1 = <strong class="jxr_keyword">new</strong> ArrayList&lt;State&gt;();
<a class="jxr_linenumber" name="L81" href="#L81">81</a>      <strong class="jxr_keyword">if</strong> ((des1 instanceof State)) {
<a class="jxr_linenumber" name="L82" href="#L82">82</a>        path1.add(((State)des1));
<a class="jxr_linenumber" name="L83" href="#L83">83</a>      }
<a class="jxr_linenumber" name="L84" href="#L84">84</a>      Region _container = des1.getContainer();
<a class="jxr_linenumber" name="L85" href="#L85">85</a>      State owner1 = _container.getState();
<a class="jxr_linenumber" name="L86" href="#L86">86</a>      <strong class="jxr_keyword">while</strong> ((!Objects.equal(owner1, <strong class="jxr_keyword">null</strong>))) {
<a class="jxr_linenumber" name="L87" href="#L87">87</a>        {
<a class="jxr_linenumber" name="L88" href="#L88">88</a>          path1.add(owner1);
<a class="jxr_linenumber" name="L89" href="#L89">89</a>          Region _container_1 = owner1.getContainer();
<a class="jxr_linenumber" name="L90" href="#L90">90</a>          State _state = _container_1.getState();
<a class="jxr_linenumber" name="L91" href="#L91">91</a>          owner1 = _state;
<a class="jxr_linenumber" name="L92" href="#L92">92</a>        }
<a class="jxr_linenumber" name="L93" href="#L93">93</a>      }
<a class="jxr_linenumber" name="L94" href="#L94">94</a>      Vertex owner2 = des2;
<a class="jxr_linenumber" name="L95" href="#L95">95</a>      <strong class="jxr_keyword">while</strong> (((!Objects.equal(owner2, <strong class="jxr_keyword">null</strong>)) &amp;&amp; ret.isEmpty())) {
<a class="jxr_linenumber" name="L96" href="#L96">96</a>        {
<a class="jxr_linenumber" name="L97" href="#L97">97</a>          <strong class="jxr_keyword">for</strong> (<strong class="jxr_keyword">final</strong> State s : path1) {
<a class="jxr_linenumber" name="L98" href="#L98">98</a>            <strong class="jxr_keyword">boolean</strong> _and = false;
<a class="jxr_linenumber" name="L99" href="#L99">99</a>            Region _container_1 = s.getContainer();
<a class="jxr_linenumber" name="L100" href="#L100">100</a>           Region _container_2 = owner2.getContainer();
<a class="jxr_linenumber" name="L101" href="#L101">101</a>           <strong class="jxr_keyword">boolean</strong> _equals = Objects.equal(_container_1, _container_2);
<a class="jxr_linenumber" name="L102" href="#L102">102</a>           <strong class="jxr_keyword">if</strong> (!_equals) {
<a class="jxr_linenumber" name="L103" href="#L103">103</a>             _and = false;
<a class="jxr_linenumber" name="L104" href="#L104">104</a>           } <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L105" href="#L105">105</a>             _and = (owner2 instanceof State);
<a class="jxr_linenumber" name="L106" href="#L106">106</a>           }
<a class="jxr_linenumber" name="L107" href="#L107">107</a>           <strong class="jxr_keyword">if</strong> (_and) {
<a class="jxr_linenumber" name="L108" href="#L108">108</a>             ret.add(s);
<a class="jxr_linenumber" name="L109" href="#L109">109</a>             ret.add(((State) owner2));
<a class="jxr_linenumber" name="L110" href="#L110">110</a>           }
<a class="jxr_linenumber" name="L111" href="#L111">111</a>         }
<a class="jxr_linenumber" name="L112" href="#L112">112</a>         Region _container_3 = owner2.getContainer();
<a class="jxr_linenumber" name="L113" href="#L113">113</a>         State _state = _container_3.getState();
<a class="jxr_linenumber" name="L114" href="#L114">114</a>         owner2 = _state;
<a class="jxr_linenumber" name="L115" href="#L115">115</a>       }
<a class="jxr_linenumber" name="L116" href="#L116">116</a>     }
<a class="jxr_linenumber" name="L117" href="#L117">117</a>     <strong class="jxr_keyword">return</strong> ret;
<a class="jxr_linenumber" name="L118" href="#L118">118</a>   }
<a class="jxr_linenumber" name="L119" href="#L119">119</a>   
<a class="jxr_linenumber" name="L120" href="#L120">120</a>   <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> State findInitialState(<strong class="jxr_keyword">final</strong> Region r) {
<a class="jxr_linenumber" name="L121" href="#L121">121</a>     Pseudostate pseudoDefault = TransformationUtil.firstPseudoState(r, PseudostateKind.INITIAL_LITERAL);
<a class="jxr_linenumber" name="L122" href="#L122">122</a>     <strong class="jxr_keyword">boolean</strong> _notEquals = (!Objects.equal(pseudoDefault, <strong class="jxr_keyword">null</strong>));
<a class="jxr_linenumber" name="L123" href="#L123">123</a>     <strong class="jxr_keyword">if</strong> (_notEquals) {
<a class="jxr_linenumber" name="L124" href="#L124">124</a>       EList&lt;Transition&gt; _outgoings = pseudoDefault.getOutgoings();
<a class="jxr_linenumber" name="L125" href="#L125">125</a>       Transition _head = IterableExtensions.&lt;Transition&gt;head(_outgoings);
<a class="jxr_linenumber" name="L126" href="#L126">126</a>       Vertex _target = _head.getTarget();
<a class="jxr_linenumber" name="L127" href="#L127">127</a>       <strong class="jxr_keyword">return</strong> ((State) _target);
<a class="jxr_linenumber" name="L128" href="#L128">128</a>     }
<a class="jxr_linenumber" name="L129" href="#L129">129</a>     <strong class="jxr_keyword">return</strong> <strong class="jxr_keyword">null</strong>;
<a class="jxr_linenumber" name="L130" href="#L130">130</a>   }
<a class="jxr_linenumber" name="L131" href="#L131">131</a>   
<a class="jxr_linenumber" name="L132" href="#L132">132</a>   <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> String getInitialEffect(<strong class="jxr_keyword">final</strong> Region r) {
<a class="jxr_linenumber" name="L133" href="#L133">133</a>     Pseudostate pseudoDefault = TransformationUtil.firstPseudoState(r, PseudostateKind.INITIAL_LITERAL);
<a class="jxr_linenumber" name="L134" href="#L134">134</a>     <strong class="jxr_keyword">boolean</strong> _notEquals = (!Objects.equal(pseudoDefault, <strong class="jxr_keyword">null</strong>));
<a class="jxr_linenumber" name="L135" href="#L135">135</a>     <strong class="jxr_keyword">if</strong> (_notEquals) {
<a class="jxr_linenumber" name="L136" href="#L136">136</a>       EList&lt;Transition&gt; _outgoings = pseudoDefault.getOutgoings();
<a class="jxr_linenumber" name="L137" href="#L137">137</a>       Transition t = IterableExtensions.&lt;Transition&gt;head(_outgoings);
<a class="jxr_linenumber" name="L138" href="#L138">138</a>       <strong class="jxr_keyword">boolean</strong> _and = false;
<a class="jxr_linenumber" name="L139" href="#L139">139</a>       Behavior _effect = t.getEffect();
<a class="jxr_linenumber" name="L140" href="#L140">140</a>       <strong class="jxr_keyword">boolean</strong> _notEquals_1 = (!Objects.equal(_effect, <strong class="jxr_keyword">null</strong>));
<a class="jxr_linenumber" name="L141" href="#L141">141</a>       <strong class="jxr_keyword">if</strong> (!_notEquals_1) {
<a class="jxr_linenumber" name="L142" href="#L142">142</a>         _and = false;
<a class="jxr_linenumber" name="L143" href="#L143">143</a>       } <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L144" href="#L144">144</a>         Behavior _effect_1 = t.getEffect();
<a class="jxr_linenumber" name="L145" href="#L145">145</a>         _and = (_effect_1 instanceof OpaqueBehavior);
<a class="jxr_linenumber" name="L146" href="#L146">146</a>       }
<a class="jxr_linenumber" name="L147" href="#L147">147</a>       <strong class="jxr_keyword">if</strong> (_and) {
<a class="jxr_linenumber" name="L148" href="#L148">148</a>         Behavior _effect_2 = t.getEffect();
<a class="jxr_linenumber" name="L149" href="#L149">149</a>         EList&lt;String&gt; _bodies = ((OpaqueBehavior) _effect_2).getBodies();
<a class="jxr_linenumber" name="L150" href="#L150">150</a>         <strong class="jxr_keyword">return</strong> IterableExtensions.&lt;String&gt;head(_bodies);
<a class="jxr_linenumber" name="L151" href="#L151">151</a>       }
<a class="jxr_linenumber" name="L152" href="#L152">152</a>     }
<a class="jxr_linenumber" name="L153" href="#L153">153</a>     <strong class="jxr_keyword">return</strong> <span class="jxr_string">"//no initial effect is defined"</span>;
<a class="jxr_linenumber" name="L154" href="#L154">154</a>   }
<a class="jxr_linenumber" name="L155" href="#L155">155</a>   
<a class="jxr_linenumber" name="L156" href="#L156">156</a>   <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> String getTransitionEffect(<strong class="jxr_keyword">final</strong> Transition t) {
<a class="jxr_linenumber" name="L157" href="#L157">157</a>     <strong class="jxr_keyword">boolean</strong> _and = false;
<a class="jxr_linenumber" name="L158" href="#L158">158</a>     Behavior _effect = t.getEffect();
<a class="jxr_linenumber" name="L159" href="#L159">159</a>     <strong class="jxr_keyword">boolean</strong> _notEquals = (!Objects.equal(_effect, <strong class="jxr_keyword">null</strong>));
<a class="jxr_linenumber" name="L160" href="#L160">160</a>     <strong class="jxr_keyword">if</strong> (!_notEquals) {
<a class="jxr_linenumber" name="L161" href="#L161">161</a>       _and = false;
<a class="jxr_linenumber" name="L162" href="#L162">162</a>     } <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L163" href="#L163">163</a>       Behavior _effect_1 = t.getEffect();
<a class="jxr_linenumber" name="L164" href="#L164">164</a>       _and = (_effect_1 instanceof OpaqueBehavior);
<a class="jxr_linenumber" name="L165" href="#L165">165</a>     }
<a class="jxr_linenumber" name="L166" href="#L166">166</a>     <strong class="jxr_keyword">if</strong> (_and) {
<a class="jxr_linenumber" name="L167" href="#L167">167</a>       Behavior _effect_2 = t.getEffect();
<a class="jxr_linenumber" name="L168" href="#L168">168</a>       EList&lt;String&gt; _bodies = ((OpaqueBehavior) _effect_2).getBodies();
<a class="jxr_linenumber" name="L169" href="#L169">169</a>       <strong class="jxr_keyword">return</strong> IterableExtensions.&lt;String&gt;head(_bodies);
<a class="jxr_linenumber" name="L170" href="#L170">170</a>     }
<a class="jxr_linenumber" name="L171" href="#L171">171</a>     StringConcatenation _builder = <strong class="jxr_keyword">new</strong> StringConcatenation();
<a class="jxr_linenumber" name="L172" href="#L172">172</a>     <strong class="jxr_keyword">return</strong> _builder.toString();
<a class="jxr_linenumber" name="L173" href="#L173">173</a>   }
<a class="jxr_linenumber" name="L174" href="#L174">174</a>   
<a class="jxr_linenumber" name="L175" href="#L175">175</a>   <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> List&lt;State&gt; transitiveSubStates(<strong class="jxr_keyword">final</strong> State parent) {
<a class="jxr_linenumber" name="L176" href="#L176">176</a>     <strong class="jxr_keyword">final</strong> ArrayList&lt;State&gt; ret = <strong class="jxr_keyword">new</strong> ArrayList&lt;State&gt;();
<a class="jxr_linenumber" name="L177" href="#L177">177</a>     <strong class="jxr_keyword">boolean</strong> _isComposite = parent.isComposite();
<a class="jxr_linenumber" name="L178" href="#L178">178</a>     <strong class="jxr_keyword">if</strong> (_isComposite) {
<a class="jxr_linenumber" name="L179" href="#L179">179</a>       EList&lt;Region&gt; _regions = parent.getRegions();
<a class="jxr_linenumber" name="L180" href="#L180">180</a>       <strong class="jxr_keyword">for</strong> (<strong class="jxr_keyword">final</strong> Region r : _regions) {
<a class="jxr_linenumber" name="L181" href="#L181">181</a>         {
<a class="jxr_linenumber" name="L182" href="#L182">182</a>           EList&lt;Vertex&gt; _subvertices = r.getSubvertices();
<a class="jxr_linenumber" name="L183" href="#L183">183</a>           Iterable&lt;State&gt; _filter = Iterables.&lt;State&gt;filter(_subvertices, State.<strong class="jxr_keyword">class</strong>);
<a class="jxr_linenumber" name="L184" href="#L184">184</a>           Iterables.&lt;State&gt;addAll(ret, _filter);
<a class="jxr_linenumber" name="L185" href="#L185">185</a>           EList&lt;Vertex&gt; _subvertices_1 = r.getSubvertices();
<a class="jxr_linenumber" name="L186" href="#L186">186</a>           Iterable&lt;State&gt; _filter_1 = Iterables.&lt;State&gt;filter(_subvertices_1, State.<strong class="jxr_keyword">class</strong>);
<a class="jxr_linenumber" name="L187" href="#L187">187</a>           <strong class="jxr_keyword">final</strong> Consumer&lt;State&gt; _function = <strong class="jxr_keyword">new</strong> Consumer&lt;State&gt;() {
<a class="jxr_linenumber" name="L188" href="#L188">188</a>             @Override
<a class="jxr_linenumber" name="L189" href="#L189">189</a>             <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> accept(<strong class="jxr_keyword">final</strong> State it) {
<a class="jxr_linenumber" name="L190" href="#L190">190</a>               List&lt;State&gt; _transitiveSubStates = TransformationUtil.transitiveSubStates(it);
<a class="jxr_linenumber" name="L191" href="#L191">191</a>               ret.addAll(_transitiveSubStates);
<a class="jxr_linenumber" name="L192" href="#L192">192</a>             }
<a class="jxr_linenumber" name="L193" href="#L193">193</a>           };
<a class="jxr_linenumber" name="L194" href="#L194">194</a>           _filter_1.forEach(_function);
<a class="jxr_linenumber" name="L195" href="#L195">195</a>         }
<a class="jxr_linenumber" name="L196" href="#L196">196</a>       }
<a class="jxr_linenumber" name="L197" href="#L197">197</a>     }
<a class="jxr_linenumber" name="L198" href="#L198">198</a>     <strong class="jxr_keyword">return</strong> ret;
<a class="jxr_linenumber" name="L199" href="#L199">199</a>   }
<a class="jxr_linenumber" name="L200" href="#L200">200</a>   
<a class="jxr_linenumber" name="L201" href="#L201">201</a>   <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> List&lt;State&gt; transitiveSubStates(<strong class="jxr_keyword">final</strong> Region parent) {
<a class="jxr_linenumber" name="L202" href="#L202">202</a>     <strong class="jxr_keyword">final</strong> ArrayList&lt;State&gt; ret = <strong class="jxr_keyword">new</strong> ArrayList&lt;State&gt;();
<a class="jxr_linenumber" name="L203" href="#L203">203</a>     EList&lt;Vertex&gt; _subvertices = parent.getSubvertices();
<a class="jxr_linenumber" name="L204" href="#L204">204</a>     Iterable&lt;State&gt; _filter = Iterables.&lt;State&gt;filter(_subvertices, State.<strong class="jxr_keyword">class</strong>);
<a class="jxr_linenumber" name="L205" href="#L205">205</a>     <strong class="jxr_keyword">final</strong> Function1&lt;State, Boolean&gt; _function = <strong class="jxr_keyword">new</strong> Function1&lt;State, Boolean&gt;() {
<a class="jxr_linenumber" name="L206" href="#L206">206</a>       @Override
<a class="jxr_linenumber" name="L207" href="#L207">207</a>       <strong class="jxr_keyword">public</strong> Boolean apply(<strong class="jxr_keyword">final</strong> State it) {
<a class="jxr_linenumber" name="L208" href="#L208">208</a>         <strong class="jxr_keyword">return</strong> Boolean.valueOf((!(it instanceof FinalState)));
<a class="jxr_linenumber" name="L209" href="#L209">209</a>       }
<a class="jxr_linenumber" name="L210" href="#L210">210</a>     };
<a class="jxr_linenumber" name="L211" href="#L211">211</a>     Iterable&lt;State&gt; _filter_1 = IterableExtensions.&lt;State&gt;filter(_filter, _function);
<a class="jxr_linenumber" name="L212" href="#L212">212</a>     <strong class="jxr_keyword">final</strong> Consumer&lt;State&gt; _function_1 = <strong class="jxr_keyword">new</strong> Consumer&lt;State&gt;() {
<a class="jxr_linenumber" name="L213" href="#L213">213</a>       @Override
<a class="jxr_linenumber" name="L214" href="#L214">214</a>       <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> accept(<strong class="jxr_keyword">final</strong> State it) {
<a class="jxr_linenumber" name="L215" href="#L215">215</a>         ret.add(it);
<a class="jxr_linenumber" name="L216" href="#L216">216</a>         List&lt;State&gt; _transitiveSubStates = TransformationUtil.transitiveSubStates(it);
<a class="jxr_linenumber" name="L217" href="#L217">217</a>         ret.addAll(_transitiveSubStates);
<a class="jxr_linenumber" name="L218" href="#L218">218</a>       }
<a class="jxr_linenumber" name="L219" href="#L219">219</a>     };
<a class="jxr_linenumber" name="L220" href="#L220">220</a>     _filter_1.forEach(_function_1);
<a class="jxr_linenumber" name="L221" href="#L221">221</a>     <strong class="jxr_keyword">return</strong> ret;
<a class="jxr_linenumber" name="L222" href="#L222">222</a>   }
<a class="jxr_linenumber" name="L223" href="#L223">223</a>   
<a class="jxr_linenumber" name="L224" href="#L224">224</a>   <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L225" href="#L225">225</a> <em class="jxr_javadoccomment">   * Return the name of an event (remove non-ASCII characters)</em>
<a class="jxr_linenumber" name="L226" href="#L226">226</a> <em class="jxr_javadoccomment">   */</em>
<a class="jxr_linenumber" name="L227" href="#L227">227</a>   <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> String eventName(<strong class="jxr_keyword">final</strong> Event event) {
<a class="jxr_linenumber" name="L228" href="#L228">228</a>     String _xblockexpression = <strong class="jxr_keyword">null</strong>;
<a class="jxr_linenumber" name="L229" href="#L229">229</a>     {
<a class="jxr_linenumber" name="L230" href="#L230">230</a>       String name = <span class="jxr_string">""</span>;
<a class="jxr_linenumber" name="L231" href="#L231">231</a>       <strong class="jxr_keyword">boolean</strong> repeat = false;
<a class="jxr_linenumber" name="L232" href="#L232">232</a>       String _name = event.getName();
<a class="jxr_linenumber" name="L233" href="#L233">233</a>       <strong class="jxr_keyword">char</strong>[] _charArray = _name.toCharArray();
<a class="jxr_linenumber" name="L234" href="#L234">234</a>       <strong class="jxr_keyword">for</strong> (<strong class="jxr_keyword">final</strong> <strong class="jxr_keyword">char</strong> c : _charArray) {
<a class="jxr_linenumber" name="L235" href="#L235">235</a>         <strong class="jxr_keyword">boolean</strong> _or = false;
<a class="jxr_linenumber" name="L236" href="#L236">236</a>         <strong class="jxr_keyword">boolean</strong> _isAlphabetic = Character.isAlphabetic(c);
<a class="jxr_linenumber" name="L237" href="#L237">237</a>         <strong class="jxr_keyword">if</strong> (_isAlphabetic) {
<a class="jxr_linenumber" name="L238" href="#L238">238</a>           _or = <strong class="jxr_keyword">true</strong>;
<a class="jxr_linenumber" name="L239" href="#L239">239</a>         } <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L240" href="#L240">240</a>           <strong class="jxr_keyword">boolean</strong> _isDigit = Character.isDigit(c);
<a class="jxr_linenumber" name="L241" href="#L241">241</a>           _or = _isDigit;
<a class="jxr_linenumber" name="L242" href="#L242">242</a>         }
<a class="jxr_linenumber" name="L243" href="#L243">243</a>         <strong class="jxr_keyword">if</strong> (_or) {
<a class="jxr_linenumber" name="L244" href="#L244">244</a>           String _name_1 = name;
<a class="jxr_linenumber" name="L245" href="#L245">245</a>           name = (_name_1 + Character.valueOf(c));
<a class="jxr_linenumber" name="L246" href="#L246">246</a>           repeat = false;
<a class="jxr_linenumber" name="L247" href="#L247">247</a>         } <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L248" href="#L248">248</a>           <strong class="jxr_keyword">if</strong> ((!repeat)) {
<a class="jxr_linenumber" name="L249" href="#L249">249</a>             String _name_2 = name;
<a class="jxr_linenumber" name="L250" href="#L250">250</a>             name = (_name_2 + <span class="jxr_string">"_"</span>);
<a class="jxr_linenumber" name="L251" href="#L251">251</a>             repeat = <strong class="jxr_keyword">true</strong>;
<a class="jxr_linenumber" name="L252" href="#L252">252</a>           }
<a class="jxr_linenumber" name="L253" href="#L253">253</a>         }
<a class="jxr_linenumber" name="L254" href="#L254">254</a>       }
<a class="jxr_linenumber" name="L255" href="#L255">255</a>       _xblockexpression = name;
<a class="jxr_linenumber" name="L256" href="#L256">256</a>     }
<a class="jxr_linenumber" name="L257" href="#L257">257</a>     <strong class="jxr_keyword">return</strong> _xblockexpression;
<a class="jxr_linenumber" name="L258" href="#L258">258</a>   }
<a class="jxr_linenumber" name="L259" href="#L259">259</a>   
<a class="jxr_linenumber" name="L260" href="#L260">260</a>   <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L261" href="#L261">261</a> <em class="jxr_javadoccomment">   * Return the ID of an event</em>
<a class="jxr_linenumber" name="L262" href="#L262">262</a> <em class="jxr_javadoccomment">   */</em>
<a class="jxr_linenumber" name="L263" href="#L263">263</a>   <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> String eventID(<strong class="jxr_keyword">final</strong> Event event) {
<a class="jxr_linenumber" name="L264" href="#L264">264</a>     String _eventName = TransformationUtil.eventName(event);
<a class="jxr_linenumber" name="L265" href="#L265">265</a>     String _upperCase = _eventName.toUpperCase();
<a class="jxr_linenumber" name="L266" href="#L266">266</a>     <strong class="jxr_keyword">return</strong> (_upperCase + <span class="jxr_string">"_ID"</span>);
<a class="jxr_linenumber" name="L267" href="#L267">267</a>   }
<a class="jxr_linenumber" name="L268" href="#L268">268</a>   
<a class="jxr_linenumber" name="L269" href="#L269">269</a>   <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> <strong class="jxr_keyword">boolean</strong> isSavehistory(<strong class="jxr_keyword">final</strong> Region topRegion, <strong class="jxr_keyword">final</strong> Region r) {
<a class="jxr_linenumber" name="L270" href="#L270">270</a>     EList&lt;Vertex&gt; _subvertices = r.getSubvertices();
<a class="jxr_linenumber" name="L271" href="#L271">271</a>     Iterable&lt;Pseudostate&gt; _filter = Iterables.&lt;Pseudostate&gt;filter(_subvertices, Pseudostate.<strong class="jxr_keyword">class</strong>);
<a class="jxr_linenumber" name="L272" href="#L272">272</a>     <strong class="jxr_keyword">final</strong> Function1&lt;Pseudostate, Boolean&gt; _function = <strong class="jxr_keyword">new</strong> Function1&lt;Pseudostate, Boolean&gt;() {
<a class="jxr_linenumber" name="L273" href="#L273">273</a>       @Override
<a class="jxr_linenumber" name="L274" href="#L274">274</a>       <strong class="jxr_keyword">public</strong> Boolean apply(<strong class="jxr_keyword">final</strong> Pseudostate it) {
<a class="jxr_linenumber" name="L275" href="#L275">275</a>         PseudostateKind _kind = it.getKind();
<a class="jxr_linenumber" name="L276" href="#L276">276</a>         <strong class="jxr_keyword">return</strong> Boolean.valueOf(Objects.equal(_kind, PseudostateKind.SHALLOW_HISTORY_LITERAL));
<a class="jxr_linenumber" name="L277" href="#L277">277</a>       }
<a class="jxr_linenumber" name="L278" href="#L278">278</a>     };
<a class="jxr_linenumber" name="L279" href="#L279">279</a>     Iterable&lt;Pseudostate&gt; _filter_1 = IterableExtensions.&lt;Pseudostate&gt;filter(_filter, _function);
<a class="jxr_linenumber" name="L280" href="#L280">280</a>     <strong class="jxr_keyword">int</strong> _size = IterableExtensions.size(_filter_1);
<a class="jxr_linenumber" name="L281" href="#L281">281</a>     <strong class="jxr_keyword">boolean</strong> _greaterThan = (_size &gt; 0);
<a class="jxr_linenumber" name="L282" href="#L282">282</a>     <strong class="jxr_keyword">if</strong> (_greaterThan) {
<a class="jxr_linenumber" name="L283" href="#L283">283</a>       <strong class="jxr_keyword">return</strong> <strong class="jxr_keyword">true</strong>;
<a class="jxr_linenumber" name="L284" href="#L284">284</a>     }
<a class="jxr_linenumber" name="L285" href="#L285">285</a>     <strong class="jxr_keyword">return</strong> TransformationUtil.isSaveDeepHistory(topRegion, r);
<a class="jxr_linenumber" name="L286" href="#L286">286</a>   }
<a class="jxr_linenumber" name="L287" href="#L287">287</a>   
<a class="jxr_linenumber" name="L288" href="#L288">288</a>   <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> <strong class="jxr_keyword">boolean</strong> isBehaviorExist(<strong class="jxr_keyword">final</strong> Behavior b) {
<a class="jxr_linenumber" name="L289" href="#L289">289</a>     <strong class="jxr_keyword">boolean</strong> ret = false;
<a class="jxr_linenumber" name="L290" href="#L290">290</a>     <strong class="jxr_keyword">boolean</strong> _and = false;
<a class="jxr_linenumber" name="L291" href="#L291">291</a>     <strong class="jxr_keyword">boolean</strong> _notEquals = (!Objects.equal(b, <strong class="jxr_keyword">null</strong>));
<a class="jxr_linenumber" name="L292" href="#L292">292</a>     <strong class="jxr_keyword">if</strong> (!_notEquals) {
<a class="jxr_linenumber" name="L293" href="#L293">293</a>       _and = false;
<a class="jxr_linenumber" name="L294" href="#L294">294</a>     } <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L295" href="#L295">295</a>       _and = (b instanceof OpaqueBehavior);
<a class="jxr_linenumber" name="L296" href="#L296">296</a>     }
<a class="jxr_linenumber" name="L297" href="#L297">297</a>     <strong class="jxr_keyword">if</strong> (_and) {
<a class="jxr_linenumber" name="L298" href="#L298">298</a>       EList&lt;String&gt; _bodies = ((OpaqueBehavior) b).getBodies();
<a class="jxr_linenumber" name="L299" href="#L299">299</a>       String _head = IterableExtensions.&lt;String&gt;head(_bodies);
<a class="jxr_linenumber" name="L300" href="#L300">300</a>       String _trim = _head.trim();
<a class="jxr_linenumber" name="L301" href="#L301">301</a>       <strong class="jxr_keyword">boolean</strong> _isEmpty = _trim.isEmpty();
<a class="jxr_linenumber" name="L302" href="#L302">302</a>       <strong class="jxr_keyword">boolean</strong> _not = (!_isEmpty);
<a class="jxr_linenumber" name="L303" href="#L303">303</a>       <strong class="jxr_keyword">if</strong> (_not) {
<a class="jxr_linenumber" name="L304" href="#L304">304</a>         ret = <strong class="jxr_keyword">true</strong>;
<a class="jxr_linenumber" name="L305" href="#L305">305</a>       }
<a class="jxr_linenumber" name="L306" href="#L306">306</a>     }
<a class="jxr_linenumber" name="L307" href="#L307">307</a>     <strong class="jxr_keyword">return</strong> ret;
<a class="jxr_linenumber" name="L308" href="#L308">308</a>   }
<a class="jxr_linenumber" name="L309" href="#L309">309</a>   
<a class="jxr_linenumber" name="L310" href="#L310">310</a>   <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> <strong class="jxr_keyword">boolean</strong> hasTriggerlessTransition(<strong class="jxr_keyword">final</strong> State s) {
<a class="jxr_linenumber" name="L311" href="#L311">311</a>     EList&lt;Transition&gt; _outgoings = s.getOutgoings();
<a class="jxr_linenumber" name="L312" href="#L312">312</a>     <strong class="jxr_keyword">final</strong> Function1&lt;Transition, Boolean&gt; _function = <strong class="jxr_keyword">new</strong> Function1&lt;Transition, Boolean&gt;() {
<a class="jxr_linenumber" name="L313" href="#L313">313</a>       @Override
<a class="jxr_linenumber" name="L314" href="#L314">314</a>       <strong class="jxr_keyword">public</strong> Boolean apply(<strong class="jxr_keyword">final</strong> Transition it) {
<a class="jxr_linenumber" name="L315" href="#L315">315</a>         EList&lt;Trigger&gt; _triggers = it.getTriggers();
<a class="jxr_linenumber" name="L316" href="#L316">316</a>         <strong class="jxr_keyword">final</strong> Function1&lt;Trigger, Event&gt; _function = <strong class="jxr_keyword">new</strong> Function1&lt;Trigger, Event&gt;() {
<a class="jxr_linenumber" name="L317" href="#L317">317</a>           @Override
<a class="jxr_linenumber" name="L318" href="#L318">318</a>           <strong class="jxr_keyword">public</strong> Event apply(<strong class="jxr_keyword">final</strong> Trigger it) {
<a class="jxr_linenumber" name="L319" href="#L319">319</a>             <strong class="jxr_keyword">return</strong> it.getEvent();
<a class="jxr_linenumber" name="L320" href="#L320">320</a>           }
<a class="jxr_linenumber" name="L321" href="#L321">321</a>         };
<a class="jxr_linenumber" name="L322" href="#L322">322</a>         List&lt;Event&gt; _map = ListExtensions.&lt;Trigger, Event&gt;map(_triggers, _function);
<a class="jxr_linenumber" name="L323" href="#L323">323</a>         <strong class="jxr_keyword">return</strong> Boolean.valueOf(_map.isEmpty());
<a class="jxr_linenumber" name="L324" href="#L324">324</a>       }
<a class="jxr_linenumber" name="L325" href="#L325">325</a>     };
<a class="jxr_linenumber" name="L326" href="#L326">326</a>     Iterable&lt;Transition&gt; _filter = IterableExtensions.&lt;Transition&gt;filter(_outgoings, _function);
<a class="jxr_linenumber" name="L327" href="#L327">327</a>     <strong class="jxr_keyword">int</strong> _size = IterableExtensions.size(_filter);
<a class="jxr_linenumber" name="L328" href="#L328">328</a>     <strong class="jxr_keyword">return</strong> (_size &gt; 0);
<a class="jxr_linenumber" name="L329" href="#L329">329</a>   }
<a class="jxr_linenumber" name="L330" href="#L330">330</a>   
<a class="jxr_linenumber" name="L331" href="#L331">331</a>   <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> <strong class="jxr_keyword">boolean</strong> isSaveDeepHistory(<strong class="jxr_keyword">final</strong> Region topRegion, <strong class="jxr_keyword">final</strong> Region r) {
<a class="jxr_linenumber" name="L332" href="#L332">332</a>     EList&lt;Vertex&gt; _subvertices = r.getSubvertices();
<a class="jxr_linenumber" name="L333" href="#L333">333</a>     Iterable&lt;Pseudostate&gt; _filter = Iterables.&lt;Pseudostate&gt;filter(_subvertices, Pseudostate.<strong class="jxr_keyword">class</strong>);
<a class="jxr_linenumber" name="L334" href="#L334">334</a>     <strong class="jxr_keyword">final</strong> Function1&lt;Pseudostate, Boolean&gt; _function = <strong class="jxr_keyword">new</strong> Function1&lt;Pseudostate, Boolean&gt;() {
<a class="jxr_linenumber" name="L335" href="#L335">335</a>       @Override
<a class="jxr_linenumber" name="L336" href="#L336">336</a>       <strong class="jxr_keyword">public</strong> Boolean apply(<strong class="jxr_keyword">final</strong> Pseudostate it) {
<a class="jxr_linenumber" name="L337" href="#L337">337</a>         PseudostateKind _kind = it.getKind();
<a class="jxr_linenumber" name="L338" href="#L338">338</a>         <strong class="jxr_keyword">return</strong> Boolean.valueOf(Objects.equal(_kind, PseudostateKind.DEEP_HISTORY_LITERAL));
<a class="jxr_linenumber" name="L339" href="#L339">339</a>       }
<a class="jxr_linenumber" name="L340" href="#L340">340</a>     };
<a class="jxr_linenumber" name="L341" href="#L341">341</a>     Iterable&lt;Pseudostate&gt; _filter_1 = IterableExtensions.&lt;Pseudostate&gt;filter(_filter, _function);
<a class="jxr_linenumber" name="L342" href="#L342">342</a>     <strong class="jxr_keyword">int</strong> _size = IterableExtensions.size(_filter_1);
<a class="jxr_linenumber" name="L343" href="#L343">343</a>     <strong class="jxr_keyword">boolean</strong> _greaterThan = (_size &gt; 0);
<a class="jxr_linenumber" name="L344" href="#L344">344</a>     <strong class="jxr_keyword">if</strong> (_greaterThan) {
<a class="jxr_linenumber" name="L345" href="#L345">345</a>       <strong class="jxr_keyword">return</strong> <strong class="jxr_keyword">true</strong>;
<a class="jxr_linenumber" name="L346" href="#L346">346</a>     }
<a class="jxr_linenumber" name="L347" href="#L347">347</a>     <strong class="jxr_keyword">boolean</strong> _notEquals = (!Objects.equal(r, topRegion));
<a class="jxr_linenumber" name="L348" href="#L348">348</a>     <strong class="jxr_keyword">if</strong> (_notEquals) {
<a class="jxr_linenumber" name="L349" href="#L349">349</a>       State _state = r.getState();
<a class="jxr_linenumber" name="L350" href="#L350">350</a>       Region nextRegion = _state.getContainer();
<a class="jxr_linenumber" name="L351" href="#L351">351</a>       <strong class="jxr_keyword">return</strong> TransformationUtil.isSaveDeepHistory(topRegion, nextRegion);
<a class="jxr_linenumber" name="L352" href="#L352">352</a>     }
<a class="jxr_linenumber" name="L353" href="#L353">353</a>     <strong class="jxr_keyword">return</strong> false;
<a class="jxr_linenumber" name="L354" href="#L354">354</a>   }
<a class="jxr_linenumber" name="L355" href="#L355">355</a> }
</pre>
<hr/>
<div id="footer">Copyright &#169; 2016 <a href="https://www.eclipse.org/">Eclipse foundation</a>. All rights reserved.</div>
</body>
</html>
